const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const payroll_line_items = sequelize.define(
    'payroll_line_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

total_hours: {
        type: DataTypes.DECIMAL,
      
      

      },

gross_pay: {
        type: DataTypes.DECIMAL,
      
      

      },

total_commission_base: {
        type: DataTypes.DECIMAL,
      
      

      },

workers_comp_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

total_client_paid: {
        type: DataTypes.DECIMAL,
      
      

      },

summary: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  payroll_line_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity















//end loop



    db.payroll_line_items.belongsTo(db.payroll_runs, {
      as: 'payroll_run',
      foreignKey: {
        name: 'payroll_runId',
      },
      constraints: false,
    });

    db.payroll_line_items.belongsTo(db.users, {
      as: 'employee',
      foreignKey: {
        name: 'employeeId',
      },
      constraints: false,
    });




    db.payroll_line_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.payroll_line_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return payroll_line_items;
};